<template>
  <v-app id="inspire">
    <v-container fluid>
      <v-layout row wrap justify-center class="mt-4">
        <v-flex xs12 sm10 text-xs-center>
          <v-text-field
                  label="Text to verify sentiment"
                  v-model="text"
                  textarea
          ></v-text-field>
        </v-flex>
        <v-flex xs12 sm10 text-xs-center>
          <v-chip class="ma-2" label>
            Sentiment: {{sentiment}}
          </v-chip>
          <v-spacer/>
          <v-chip class="ma-2" label>
            Probability: {{probability}} %
          </v-chip>
          <v-spacer/>
          <v-chip class="ma-2" label>
            Inference time: {{inferenceTime}} seconds
          </v-chip>
        </v-flex>
        <v-flex xs12 sm10 text-xs-center>
          <v-btn v-if="loading"
                  v-on:click="getSentiment()"
                  loading>Get sentiment</v-btn>
          <v-btn v-else
                 v-on:click="getSentiment()">Get sentiment</v-btn>
        </v-flex>
      </v-layout>
    </v-container>
  </v-app>
</template>

<script>
  import {mapGetters} from 'vuex'
  export default {
    name: 'Sentiment',
    data () {
      return {
        text: '',
        loading: false
      }
    },
    computed: {
      ...mapGetters('sentiment', [
        'sentiment',
        'probability',
        'inferenceTime'
      ])
    },
    methods: {
      apiSentiment(text) {
        if (text !== '') {
          this.loading = true;
          return new Promise((resolve) => {
            this.$store.dispatch('sentiment/get', {'text': text}).then(() => {
              resolve();
            });
          })
        }
      },
      getSentiment() {
        this.apiSentiment(this.text).then(() => {
          this.loading = false;
        })
      }
    }
  }
</script>
